#ifndef __OctreeCHCOcclusionCHCTraversal_H
#define __OctreeCHCOcclusionCHCTraversal_H

#include "OctreeCHCPrerequisites.h"
#include "OctreeCHCCamera.h"

#include "OctreeCHCOcclusionTraversal.h"

namespace OgreOctreeCHC
{
    //-----------------------------------------------------------------------
    // TREE TRAVERSAL classes 
    // a OctreeNode with Geometry objects in the leaves 
    // and a TreeNodeData struct at every node
    class CHCTraversal : public DepthTraversalConst, public BreadthTraversalConst 
    {
	    public:
		    void onDepthTree(SpatialTree& n) const;
			void onDepthLeaf (SpatialTreeNode& n) const ;

			void onBreadthTree(SpatialTree& n) const;
			void onBreadthLeaf(SpatialTreeNode& n) const ;

		    CHCTraversal(FrontToBackNodeSorterPriorityQueue& vStack, 
							OcclusionCulling& o, 
							Ogre::VisibleObjectsBoundsInfo * const visibleBounds);

	    private:
		    FrontToBackNodeSorterPriorityQueue& mStack;
		    OcclusionCulling& mOcclusion;
		    const unsigned int mFrameId;
			const bool mIsNotSolidScene;
			Ogre::VisibleObjectsBoundsInfo * const mVisibleBounds;
    };
}
#endif //OctreeCHCOcclusionCHCTraversal
