#ifndef __OctreeCHCOcclusionStopAndWaitTraversal_H
#define __OctreeCHCOcclusionStopAndWaitTraversal_H

#include "OctreeCHCPrerequisites.h"
#include "OctreeCHCCamera.h"

#include "OctreeCHCOcclusionTraversal.h"

namespace OgreOctreeCHC
{
    //-----------------------------------------------------------------------
    // TREE TRAVERSAL classes 
    // a OctreeNode with Geometry objects in the leaves 
    // and a TreeNodeData struct at every node
    //-----------------------------------------------------------------------
    // Basic Occlusion query use : stop and wait query result Culling
	class StopAndWaitTraversal : public DepthTraversal, public BreadthTraversal
    {
	    private:

		    OcclusionCulling& mOcclusion;
            bool mIsVisible;
            const OctreeCHCCamera * const mCamera;
			Ogre::VisibleObjectsBoundsInfo * const mVisibleBounds;

			FrontToBackNodeSorterPriorityQueue mStack;

			bool isVisible(OcclusionElement & n);

	    public:

			StopAndWaitTraversal (OcclusionCulling& o, 
								Ogre::VisibleObjectsBoundsInfo * const visibleBounds);

            void onDepthTree(SpatialTree&);
			void onDepthLeaf (SpatialTreeNode&);

			void onBreadthTree(SpatialTree&);
			void onBreadthLeaf(SpatialTreeNode&);
	};
    
}
#endif //OctreeCHCOcclusionStopAndWaitTraversal
