/***************************************************************************
OctreeCHCPrecompiledHeaders.cpp  -  description
-------------------
copyright            : (C) 2006  Tuan Kuranes
email                : tuan.kuranes@free.fr
***************************************************************************/

/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU Lesser General Public License as        *
*   published by the Free Software Foundation; either version 2 of the    *
*   License, or (at your option) any later version.                       *
*                                                                         *
***************************************************************************/
#ifndef _PRECOMP_HEADERS
#define _PRECOMP_HEADERS

#ifdef _PRECOMPILED_HEADERS

#include "OctreeCHCPrerequisites.h"

#include "Ogre.h"
#include "OgreLogManager.h"
#include "OgreHardwareBufferManager.h"
#include "OgreTextureManager.h"
#include "OgreHardwarePixelBuffer.h"
#include "OgreAxisAlignedBox.h"
#include "OgreWireBoundingBox.h"
#include "OgreRectangle2D.h"
#include "OgreCamera.h"
#include "OgreSceneNode.h"


// utility class 
#include "RadarFrustum.h"
#include "OctreeCHCPoolSet.h"
#include "OctreeCHCOcclusionBoundingBox.h"
#include "OctreeCHCOcclusionQuerySet.h"

// -------------------------------------------------------
// Octree Scene Manager (  occlusion management inside )
// -------------------------------------------------------


#include "OgreSpatialTreeManager.h"
#include "OgreSpatialTree.h"
#include "OgreSpatialTreeNode.h"

#include "OctreeCHCManager.h"
#include "OctreeCHC.h"
#include "OctreeCHCNode.h"

#include "OctreeCHCSceneManager.h"
#include "OctreeCHCCamera.h"

#include "OctreeCHCOcclusionElement.h"
#include "OctreeCHCOcclusionVisibilityData.h"
#include "OctreeCHCOcclusionSorter.h"

#include "OctreeCHCOcclusionTraversal.h"
#include "OctreeCHCQueryTraversal.h"
#include "OctreeCHCOcclusionVFTraversal.h"
#include "OctreeCHCOcclusionSWTraversal.h"
#include "OctreeCHCOcclusionCHCTraversal.h"
#include "OctreeCHCOcclusionDebugTraversal.h"
#include "OctreeCHCOcclusionCameraTraversal.h"

#include "OctreeCHCOcclusion.h"

#include "OctreeCHCRaySceneQuery.h"
#include "OctreeCHCSphereSceneQuery.h"
#include "OctreeCHCIntersectionSceneQuery.h"
#include "OctreeCHCAxisAlignedBoxSceneQuery.h"
#include "OctreeCHCPlaneBoundedVolumeListSceneQuery.h"



#endif //_PRECOMPILED_HEADERS
#endif  //_PRECOMP_HEADERS
