
#include "OctreeCHCPrecompiledHeaders.h"

#include "OctreeCHCCamera.h"
#include "OctreeCHC.h"
#include "OctreeCHCNode.h"
#include "OctreeCHCOcclusionElement.h"
#include "OctreeCHCOcclusion.h"

#include "OctreeCHCOcclusionSorter.h"
#include "OctreeCHCOcclusionTraversal.h"
#include "OctreeCHCOcclusionCHCTraversal.h"
#include "OctreeCHCOcclusionVisibilityData.h"

using namespace Ogre;


namespace OgreOctreeCHC
{

    //-----------------------------------------------------------------------
    void CHCTraversal::onDepthTree(SpatialTree& node) const 
    {
        octree_assert (node.viewFrustumVisible);
	    mOcclusion.mTraversedNodesCount++;   
        breadthTraverseChildren(node);
	}
	//-----------------------------------------------------------------------
	void CHCTraversal::onBreadthTree(SpatialTree& n) const
	{
		mStack.push (&n);
	}
	//-----------------------------------------------------------------------
	void CHCTraversal::onBreadthLeaf(SpatialTreeNode& n) const 
	{
		mStack.push (&n);
	}
    //-----------------------------------------------------------------------
    void CHCTraversal::onDepthLeaf (SpatialTreeNode& n) const 
    {		
        octree_assert (n.viewFrustumVisible);
        octree_assert (n.queriedVisible);
	    mOcclusion.mTraversedNodesCount++;
            
        if (!n.isOccluder() || mIsNotSolidScene)
			mOcclusion.queueDraw (n);
	}
    //-----------------------------------------------------------------------
	CHCTraversal::CHCTraversal(FrontToBackNodeSorterPriorityQueue& vStack, 
								OcclusionCulling& o, 
								Ogre::VisibleObjectsBoundsInfo * const visibleBounds): 
        mStack(vStack), 
        mOcclusion(o), 
        mFrameId(o.getFrame()),
		mIsNotSolidScene(mOcclusion.isNotSolidScene()),
		mVisibleBounds(visibleBounds)
    { 
    }
}